︠c8d8dd94-d406-4aa1-b273-73521dab1fc7is︠
%md

# A Simple Sage Worksheet that creates Sage Worksheets

The `write_sagews` function below creates a Sage worksheet with any desired input.  It does not yet let you specify the *output*, though you can put %auto at the start of a cell to evaluate it when the user opens the worksheet (thus generating output).

Note that `write_sagews` is pure Python (except %auto); you can copy it into any Python script to generate worksheets.

Test this out -- if it is useful to people, I'll make a more general version just be built into SMC.

︡31b310ca-01e9-491d-9561-bd520ed5e490︡{"md":"\n# A Simple Sage Worksheet that creates Sage Worksheets\n\nThe `write_sagews` function below creates a Sage worksheet with any desired input.  It does not yet let you specify the *output*, though you can put %auto at the start of a cell to evaluate it when the user opens the worksheet (thus generating output).\n\nNote that `write_sagews` is pure Python (except %auto); you can copy it into any Python script to generate worksheets.\n\nTest this out -- if it is useful to people, I'll make a more general version just be built into SMC.\n\n"}︡
︠52ca2131-b884-4b70-a59b-cf732c7cdec8︠
%auto
MARKERS = {'cell':u"\uFE20", 'output':u"\uFE21"}
from uuid import uuid4
def uuid():
    return unicode(uuid4())

def write_sagews(input_cells, filename):
    out = u""
    for x in input_cells:
        input = unicode(x, encoding='utf8')
        modes = u''
        if '%auto' in input:
            modes += u'a'
        if '%hide' in input:
            modes += u'i'
        if '%hideall' in input:
            modes += u'o'
        out += MARKERS['cell'] + uuid() + modes + MARKERS['cell'] + u'\n'
        out += input
        out += u'\n' + MARKERS['output'] + uuid() + MARKERS['output'] + u'\n'
    open(filename,'wb').write(out.encode('utf8'))

︡59eaa7e8-fcb3-44fb-a929-5c8d66bac6a4︡
︠8bf49836-e1c4-4829-a713-6347cc4b3e90s︠
# Example

write_sagews(['2+2', '%auto\na=5', '%md What is your answer?', '%auto\n%md\nThis will be **marked up**'], 'autogenerated.sagews')
︡cbe4cb68-45b1-40f9-89a7-e8481e7fd3d3︡
︠2dce87e5-3fb0-4eea-8d95-654b7a012c00is︠
%md
Try it out:

[autogenerated.sagews](autogenerated.sagews)
︡2e1787ad-cb93-4e34-93e8-313c32f3f727︡{"md":"Try it out:\n\n[autogenerated.sagews](autogenerated.sagews)\n"}︡
︠b3b56e38-1d5a-4b55-9a3d-7a69d126e8cb︠









